#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define handle_error(msg) \
    do { perror(msg); exit(EXIT_FAILURE); } while (0)

int
main(int argc, char *argv[])
{
    int i;
    unsigned int val = 0;
    char *addr;
    int fd;
    struct stat sb;
    off_t offset, pa_offset;
    size_t length;
    ssize_t s;

    if (argc < 3|| argc > 4) {
        fprintf(stderr, "%s file offset length val\n", argv[0]);
        exit(EXIT_FAILURE);
    }

    fd = open(argv[1], O_RDWR|O_SYNC);
    if (fd == -1)
        handle_error("open");

    offset = strtoul(argv[2], NULL, 16);
    val    = strtoul(argv[3], NULL, 16);

    fprintf(stderr, "%s offset : %08x, val : %08x\n", argv[0], offset, val);

    pa_offset = offset & 0xfffff000;
    offset = offset - pa_offset;

    addr = mmap(NULL, 0x1000, PROT_WRITE,
                MAP_SHARED, fd, pa_offset);
    if (addr == MAP_FAILED)
        handle_error("mmap");

    *(unsigned int *)(addr + offset) = val;
    printf("%08x\r\n", (unsigned int)(addr + offset));
    exit(EXIT_SUCCESS);
}
